medux_online/core/urls.py
from django.contrib.auth import views as auth_views
from django.urls import path, include

import medux.common.views
import medux_online.core.views as views
from medux.common.api.interfaces import IHTMXComponentMixin
from .api.interfaces import IDashboardURL

app_name = "core"

tenant_patterns = [
    path("", views.TenantListView.as_view(), name="list"),
    path("add/", views.TenantCreateView.as_view(), name="add"),
    path("<pk>/", views.TenantUpdateView.as_view(), name="detail"),
    path("<pk>/change/", views.TenantUpdateView.as_view(), name="update"),
    path("<pk>/delete/", views.TenantDeleteView.as_view(), name="delete"),
    path("<uuid:uuid>/privacy", views.PrivacyView.as_view(), name="privacy"),
    path("<uuid:uuid>/terms", views.TermsView.as_view(), name="terms"),
]

preferences_patterns = [
    path("", views.BasePreferenceListView.as_view(), name="overview"),
    # ScopedPreference CRUD
    path(
        "basepreference/<base_pk>/add-<str:scope>/",
        views.ScopedPreferenceCreateView.as_view(),
        name="add",
    ),
    path(
        "basepreference/<pk>/",
        views.BasePreferenceDetailView.as_view(),
        name="base-detail",
    ),
    path(
        "scopedpreference/<int:pk>/",
        # scopedpreference_detail,
        views.ScopedPreferenceDetailView.as_view(),
        name="detail",
    ),
    path(
        "scopedpreference/<int:pk>/update/",
        views.scopedpreference_update,
        name="update",
    ),
    path(
        "scopedpreference/<int:pk>/delete/",
        views.ScopedPreferenceDeleteView.as_view(),
        name="delete",
    ),
    path("set-tenant/<int:pk>/", views.set_active_tenant, name="set-tenant"),
]
# user_profile_patterns = [
#     # user:profile: namespace
#     path("masterdata", views.UserProfileMasterDataView.as_view(), name="master-data"),
#     path("password", views.UserProfilePasswordView.as_view(), name="password"),
#     path("groups", views.UserProfileGroupsView.as_view(), name="groups"),
# ]
user_patterns = [
    # user: namespace
    path("", views.UserListView.as_view(), name="list"),
    path(
        "<int:pk>/detail/", medux.common.views.UserUpdateView.as_view(), name="detail"
    ),
    path("add/", views.UserCreateView.as_view(), name="add"),
    path(
        "<int:pk>/update/", medux.common.views.UserUpdateView.as_view(), name="update"
    ),
    path("<int:pk>/delete/", views.UserDeleteView.as_view(), name="delete"),
    path("profile/", medux.common.views.UserProfileView.as_view(), name="profile"),
]

root_urlpatterns = [
    path("auth/", auth_views.PasswordChangeView.as_view()),
    # FIXME: should be included in Conjunto...
    # path(
    #     "__elements__/",
    #     include(
    #         (IHtmxComponentMixin.get_url_patterns(), "components"),
    #         namespace="components",
    #     ),
    # ),
]


class CoreDashboardURLs(IDashboardURL):
    urlpatterns = [
        path("tenant/", include((tenant_patterns, "tenant"), namespace="tenant")),
        path(
            "preferences/",
            include((preferences_patterns, "preferences"), namespace="preferences"),
        ),
        path(
            "user/",
            include((user_patterns, "user"), namespace="user"),
        ),
    ]

medux_online/urls.py
from functools import wraps

from django.conf import settings
from django.conf.urls.static import static
from django.contrib import admin
from django.core.exceptions import PermissionDenied
from django.urls import path, include
from gdaps.pluginmanager import PluginManager

from .core.api.interfaces import IDashboardURL
from .core.views import DashboardView

app_name = "medux_online"


def medux_site_required(test_func=None):
    """
    Decorator for views that checks that the current site is the main
    medux site. If not, raise a PermissionDenied error
    """

    def site_is_medux(view_func):
        @wraps(view_func)
        def _wrapped_view(request, *args, **kwargs):
            if request.site == 1:
                return True
            raise PermissionDenied

        return _wrapped_view

    return site_is_medux


# create a pluggable "dashboard" urlpatterns hook
dashboard_urlpatterns = [
    path("", DashboardView.as_view(), name="index"),
]
for up in IDashboardURL:
    dashboard_urlpatterns += up.urlpatterns

urlpatterns = [
    # TODO make admin only available on SIDE_ID=1
    path("admin/", admin.site.urls, name="admin"),
    path(
        "dashboard/",
        # dashboard is no namespace, only part of the URL
        include((dashboard_urlpatterns, ""), namespace=""),
        name="index",
    ),
    path("__debug__/", include("debug_toolbar.urls")),
] + PluginManager.urlpatterns()

if settings.DEBUG:
    urlpatterns += static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)
    urlpatterns += static(settings.STATIC_URL, document_root=settings.STATIC_ROOT)

medux_online/plugins/homepage/models.py
from datetime import datetime
from pathlib import Path

from colorfield.fields import ColorField
from django.contrib.auth.signals import user_logged_in
from django.contrib.sites.models import Site
from django.core.files.storage import Storage
from django.core.validators import MinValueValidator, MaxValueValidator, validate_slug
from django.db import models
from django.shortcuts import redirect
from django.urls import reverse_lazy
from django.utils.text import slugify, re_camel_case
from django.utils.translation import gettext_lazy as _
from polymorphic.models import PolymorphicModel

# FIXME: Bah, that ZipExtractorStorage can't work.
from medux.common.models import TenantModelMixin


# from zipfile import ZipFile
# # thanks to https://goodcode.io/articles/django-singleton-models/
# class SingletonModel(models.Model):
#     class Meta:
#         abstract = True
#
#     def save(self, *args, **kwargs):
#         self.__class__.objects.exclude(id=self.id).delete()
#         super(SingletonModel, self).save(*args, **kwargs)
#
#     @classmethod
#     def load(cls):
#         try:
#             return cls.objects.get()
#         except cls.DoesNotExist:
#             return cls()


class ZipExtractorStorage(Storage):
    """Dummy"""

    def save(self, name, content, max_length=None):
        # with ZipFile(name) as zip_file:
        #     upload_path = self.get_upload_path(self, self.package.name)
        #     zip_file.extractall(self.get_upload_path() / self.slug)
        #     # TODO: do something with uploaded file
        pass


class Theme(models.Model):
    # TODO: determine a way to allow only own tenant's themes, or to explicitly allow others, per theme
    def get_upload_path(self, instance: "Theme", filename: str):
        return Path("themes")  # / instance.homepage.name

    slug = models.CharField(max_length=64, validators=[validate_slug])
    title = models.CharField(max_length=255)
    package = models.FileField(
        upload_to=get_upload_path, storage=ZipExtractorStorage, null=True, blank=True
    )

    def __str__(self):
        return self.title

    def save(self, *args, **kwargs):

        if not self.slug:
            self.slug = slugify(self.title)
        super().save(*args, **kwargs)


class ColoredMixin(models.Model):
    class Meta:
        abstract = True

    color_accent = ColorField()
    text_primary = ColorField()
    text_secondary = ColorField()
    text_success = ColorField()
    text_danger = ColorField()
    text_warning = ColorField()
    text_info = ColorField()
    text_light = ColorField()
    text_dark = ColorField()
    text_muted = ColorField()
    text_white = ColorField()

    bg_primary = ColorField()
    bg_secondary = ColorField()
    bg_light = ColorField()
    bg_dark = ColorField()


class Homepage(TenantModelMixin, Site):
    subtitle = models.CharField(
        _("Subtitle"),
        help_text=_("A subtitle that appears on the homepage, depending on the theme."),
        max_length=255,
        blank=True,
        null=True,
    )
    logo = models.ImageField(
        _("Logo"), help_text=_("Homepage Logo"), blank=True, null=True
    )

    theme = models.ForeignKey(Theme, default=1, on_delete=models.SET_DEFAULT)

    def __str__(self):
        return self.name


class MultiHomepagesMixin(models.Model):
    """A mixin that can be added to a model to mark it as belonging to more than one homepage."""

    class Meta:
        abstract = True

    homepages = models.ManyToManyField(Homepage)


class SingleHomepageMixin(models.Model):
    """A mixin that can be added to a model to mark it as belonging to exactly one homepage."""

    class Meta:
        abstract = True

    homepage = models.ForeignKey(Homepage, on_delete=models.CASCADE)


# Note: SingleHomepageMixin is 2nd in the list, so that objects is called first from PolymorphicModel.
# This is needed for PolymorphicModel to get no ManagerInheritanceWarning.
class Block(PolymorphicModel):
    """A basic HTML/renderable block.

    You can either create a Block directly, and fill out the title and content, and it will be rendered
    as HTML. The order of the block is determined by the "weight" property: the higher the weight, the
    "deeper" sinks the block down.

    If you subclass Block, you can add model fields. Just make sure you add these fields to the
    "additional_fields" list property, so they will be added to the template context.
    """

    class Meta:
        verbose_name = _("Common block")
        verbose_name_plural = _("Common blocks")

    homepage = models.ForeignKey(
        Homepage, on_delete=models.CASCADE, related_name="blocks"
    )

    #: should the title be editable?
    edit_title = False
    #: should the content be editable
    edit_content = False

    additional_fields = []
    template_name = "block.html"

    title = models.CharField(_("Title"), max_length=50, blank=True)
    show_title = models.BooleanField(
        default=True, verbose_name=_("Show title on homepage")
    )
    content = models.TextField(_("Content"), blank=True)
    weight = models.SmallIntegerField(_("Weight"), default=0)

    visible = models.BooleanField(_("Visible"), default=False)

    # def __str__(self):
    # (
    #     f"{self.title} ({self.tenant.name})"
    #     if self.title
    #     else f"{self._meta.verbose_name.capitalize()} ({self.tenant.name})"
    # )

    def verbose_name(self):
        return self._meta.verbose_name

    def btype(self) -> str:
        """:returns the block type (=basically the lowercase class name) as string."""
        class_name = self.__class__.__name__
        return re_camel_case.sub(r"_\1", class_name).strip("_").lower()

    def __str__(self):
        return f"{self.title} ({self.homepage})"

    @property
    def tenant(self):
        return self.homepage.tenant


class Header(Block):
    class Meta:
        verbose_name = _("Header")
        verbose_name_plural = _("Headers")

    template_name = "header.html"
    additional_fields = ["logo", "background_image"]

    logo = models.ImageField(blank=True, null=True)
    background_image = models.ImageField(blank=True, null=True)


class News(Block):
    class Meta:
        verbose_name = _("News")
        verbose_name_plural = _("News")

    template_name = "news.html"


class OpeningHours(Block):
    """Opening hours, that can be rendered in a block"""

    class Meta:
        verbose_name = _("Opening hours")
        verbose_name_plural = _("Opening hours")

    template_name = "opening_hours.html"
    additional_fields = ["entries", "weekdays_count"]

    def weekdays_count(self) -> int:
        """returns distinct count of week days that are open.

        E.g. if opening hours are MO 8-12, WE 8-12 + 15-18, FR 8-12; then it would return 3."""
        # FIXME: use a distinct call
        return self.entries.count()


class OpeningHourSlot(models.Model):
    """Single block of opening hours, e.g. '8:00 - 12:00'"""

    DAYS_CHOICES = (
        (0, _("MO")),
        (1, _("TU")),
        (2, _("WE")),
        (3, _("TH")),
        (4, _("FR")),
        (5, _("SA")),
        (6, _("SU")),
    )
    day = models.PositiveSmallIntegerField(
        choices=DAYS_CHOICES,
        validators=[MinValueValidator(0), MaxValueValidator(6)],
        null=True,
    )
    start = models.TimeField()
    end = models.TimeField()
    opening_hours = models.ForeignKey(
        OpeningHours, on_delete=models.CASCADE, related_name="entries"
    )

    def __str__(self) -> str:
        return f"{self.day_str()}, {self.start} - {self.end}"

    def is_today(self) -> bool:
        return datetime.today().weekday() == self.day

    def day_str(self) -> str:
        """returns the day as (translated) 2 char str."""
        return self.DAYS_CHOICES[self.day][1]


class Map(Block):
    """A Block with a GDPR-compliant map image pointing to a OSM, Google Maps, or other map service point."""

    class Meta:
        verbose_name = _("Map")
        verbose_name_plural = _("Maps")

    template_name = "map.html"
    additional_fields = ["address", "link_image", "location_url"]

    address = models.CharField(max_length=128, verbose_name=_("Address"))
    link_image = models.ImageField(upload_to="map_images", blank=True, null=True)
    location_url = models.URLField(
        max_length=255,
        verbose_name=_("Location URL"),
        help_text=_("Link that points to OpenStreetMap, Google Maps etc."),
    )


class Contact(Block):
    class Meta:
        verbose_name = _("Contact")
        verbose_name_plural = _("Contacts")

    def get_homepage_email(self):
        return self.tenant.email  # FIXME

    additional_fields = ["email"]
    template_name = "contact.html"

    email = models.EmailField()


class Team(Block):
    class Meta:
        verbose_name = _("Team")
        verbose_name_plural = _("Teams")

    template_name = "team.html"
    additional_fields = ["members"]


class TeamMember(SingleHomepageMixin, models.Model):
    """A team member with a name, function, description and photo."""

    class Meta:
        verbose_name = _("Team member")
        verbose_name_plural = _("Team members")

    @staticmethod
    def _get_team():
        pass

    team = models.ForeignKey(Team, on_delete=models.CASCADE, related_name="members")
    name = models.CharField(_("Name"), max_length=50)
    function = models.CharField(_("Function"), max_length=50, blank=True)
    description = models.TextField(_("Description"), blank=True)
    image = models.ImageField(_("Photo"), blank=True, null=True)

    def __str__(self):
        return self.name

    def save(
        self, force_insert=False, force_update=False, using=None, update_fields=None
    ):
        # FIXME: make homepage links work
        team, created = Team.objects.get_or_create(homepage=self.homepage)
        if created:
            team.tenant = self.homepage.foo

        self.team = team
        super().save(force_insert, force_update, using, update_fields)

medux_online/core/forms/tenant.py
from crispy_forms.helper import FormHelper
from crispy_forms.layout import Layout, Row, Column, Submit
from django import forms
from django.utils.translation import gettext_lazy as _

from medux.common.models import Tenant, SexChoices


# TODO: TenantFormFixin to enable tenant aware generic forms.
# class TenantFormMixin:
#     """A mixin that adds the current request's tenant to the form data.
#
#     Make sure the view using this form has :class:`TenantViewMixin` included.
#     """
#
#     def __init__(self, *args, **kwargs):
#         self.tenant = kwargs["initial"].pop("tenant")
#         super().__init__(self, *args, **kwargs)
#
#     def clean(self):
#         super().clean()
#         self.cleaned_data["tenant_id"] = self.tenant.id


class TenantForm(forms.ModelForm):
    class Meta:
        model = Tenant
        exclude = ["uuid"]

    sex = forms.ChoiceField(
        label=_("Sex"),
        choices=SexChoices.choices,
        # widget=RadioSelectButtonGroup,
    )

    def __init__(self, *args, **kwargs):
        super().__init__(*args, **kwargs)
        self.helper = FormHelper(self)
        self.helper.layout = Layout(
            Row(Column("title"), Column("first_name"), Column("last_name")),
            Row(
                Column("sex"),  # Field("sex", css_class="btn-check")
                Column("address"),
                Column("phone"),
                Column("email"),
            ),
        )
        self.helper.add_input(Submit("submit", _("Save")))
        if self.instance.pk:
            self.helper.add_input(Submit("delete", _("Delete"), css_class="btn-danger"))

medux_online/core/templates/common/object_confirm_delete.html
{% extends "core/page.html" %}
{% load i18n crispy_forms_tags medux %}

{% block page_title %}
  {% blocktranslate %}Delete '{{ object }}'{% endblocktranslate %}
{% endblock %}

{% block content %}
  <form method="post">{% csrf_token %}
    {% with object|class_name as class %}
      <p>{% blocktranslate %}Do you really want to delete the {{ class }} '{{ object }}'?{% endblocktranslate %}</p>
    {% endwith %}
    <input type="submit" value="{% translate 'Confirm' %}" class="btn btn-danger">
    <a href="{{ object.get_absolute_url }}" class="btn btn-secondary">{% translate 'Cancel' %}</a>
  </form>
{% endblock %}

medux_online/core/templates/common/user_change_form.html
{% extends "core/page.html" %}
{% load i18n crispy_forms_tags breadcrumbs %}

{% block title %}
  {% translate 'Administration' %} - {% translate 'Users' %}
{% endblock %}

{% block page_title %}
  {% if object %}
    {% translate 'User' %}: <span id="page-title-user">{{ object }}</span>
  {% else %}
    {% translate 'Edit profile' %}
  {% endif %}
{% endblock %}

{% block breadcrumbs %}
  {{ block.super }}
  {% breadcrumb "User profile" path=request.path %}
{% endblock %}

{% block content %}
  <div class="card">
    <div class="row">
      <div class="col-2">
        <div class="card-header">
          <ul data-bs-toggle="tabs" role="tablist" class="nav nav-tabs card-header-tabs nav-vertical flex-column pe-0" aria-orientation="vertical">
            {% for element in elements.ISettingsSection %}
              <li class="nav-item" role="presentation">
                <a
                    href="#user-profile-{{ element.name }}"
                    class="nav-link{% if forloop.first %} active{% endif %}"
                    data-bs-toggle="tab"
                    aria-selected="true"
                    role="tab"
                    hx-get="{% url element.get_view_name pk=object.id %}"
                    hx-target="#user-profile-{{ element.name }}"
                    hx-trigger="{% if forloop.first %}load{% else %}click{% endif %} once"
                >
                  <i class="bi bi-{{ element.icon }} me-1"></i>
                  {{ element.title }}
                </a>
              </li>
            {% endfor %}

          </ul>
        </div>
      </div>
      <div class="col-8">
        <div class="card-body">
          <div class="tab-content">
            {% for element in elements.ISettingsSection %}
              <div
                  class="tab-pane{% if forloop.first %} active show{% endif %}"
                  id="user-profile-{{ element.name }}"
                  role="tabpanel"
              >
              </div>
            {% endfor %}
          </div>
        </div>
      </div>
    </div>
  </div>
{% endblock %}

medux_online/core/templates/common/user_create_form.html
{% extends "core/page.html" %}
{% load i18n crispy_forms_tags breadcrumbs %}

{% block title %}
  {% translate 'Administration' %} - {% translate 'Add new user' %}
{% endblock %}

{% block page_title %}{% translate 'Add new user' %}{% endblock %}

{% block breadcrumbs %}
  {{ block.super }}
  {% breadcrumb "Users" "user:list" %}
  {% breadcrumb "Add user" path=request.path %}
{% endblock %}

{% block content %}
  {% crispy form %}
{% endblock %}

medux_online/core/templates/common/user_list.html
{% extends "core/page.html" %}
{% load i18n breadcrumbs %}

{% block title %}
  {% translate 'Administration' %} - {% translate 'Users' %}
{% endblock %}

{% block page_title %}
  {% translate 'Users' %}
{% endblock %}

{% block page_menu %}
  <a class="btn btn-sm btn-outline-secondary" href="{% url 'user:add' %}"><i class="bi bi-plus-lg"></i></a>
{% endblock %}

{% block breadcrumbs %}
  {{ block.super }}
  {% breadcrumb "Users" path=request.path %}
{% endblock %}

{% block content %}
  <div class="container-fluid">
    <div class="col-12">
      <div class="card">
        {# <div class="card-header">#}
        {#   <h3 class="card-title">People</h3>#}
        {# </div>#}
        <div class="list-group list-group-flush overflow-auto" style="max-height: 35rem">
          {% for user in user_list %}
            {% with user.last_name|first|upper as initial %}
              {% ifchanged initial %}
                <div class="list-group-header sticky-top">{{ initial }}</div>
              {% endifchanged %}
              <div class="list-group-item">
                <div class="row">
                  <div class="col-auto">
                    <a href="{% url 'user:detail' user.pk %}">
                      <span class="avatar" {% if user.avatar %}style="background-image: url({{ user.avatar.url }})"{% endif %}></span>
                    </a>
                  </div>
                  <div class="col text-truncate">
                    <a href="{% url 'user:update' user.pk %}" class="text-body d-block fs-2">
                      {{ user.last_name }}, {{ user.first_name }}{% if user.title %}, {{ user.title }}{% endif %}
                    </a>
                    <div class="text-muted text-truncate mt-n1">
                      <i class='bi bi-person'></i>
                      {{ user.username }}
                    </div>
                    <div class="text-muted text-truncate mt-n1" title="{% translate 'Tenant' %}">
                      <i class='bi bi-file-person'></i>
                      {{ user.tenant }}
                    </div>
                    <div class="text-muted text-truncate mt-n1">
                      <i class='bi bi-card-list'></i>
                      {{ user.job_title }}
                    </div>
                  </div>
                  <div class="col d-none d-md-block text-truncate">
                    <div class="text-muted text-truncate mt-n1">
                      <span class='fs-6'><i class="bi bi-envelope-at"></i></span>
                      {% if user.email %}
                        <a href="mailto:{{ user.email }}">{{ user.email }}</a>
                      {% else %}
                        ---
                      {% endif %}
                    </div>
                    <div class="text-muted text-truncate mt-n1">
                      <i class='bi bi-telephone'></i>
                      {% if user.phone %}
                        {{ user.phone }}
                      {% else %}
                        ---
                      {% endif %}
                    </div>                  </div>
                  <div class="col text-truncate">
                    <ul class='list-unstyled'>
                      {% for homepage in user.tenant.homepage_set.all %}
                        <li class='list'>{{ homepage.domain }}</li>
                      {% endfor %}
                    </ul>
                  </div>
                </div>
              </div>
            {% endwith %}
          {% endfor %}

        </div>
      </div>
    </div>
  </div>
{% endblock %}

medux_online/core/templates/common/user_profile_section.html
{% load crispy_forms_tags i18n %}

<form hx-post="{{ view.request.path }}" id="user-profile-form-{{ view.name }}" enctype="multipart/form-data">
  {% if form.errors %}
    {% for error in form.non_field_errors %}
      <div class="alert alert-danger">
        <strong>{{ error|escape }}</strong>
      </div>
    {% endfor %}
  {% endif %}
  {% crispy form %}
</form>

<div id="page-title-user" hx-swap-oob="true"> {{ object }}</div>

{# if we are editing a logged in user, change the user menu above too #}
{% if object == request.user %}
  <div id="user-menu-user" hx-swap-oob="true">{{ object }}</div>
  <span id="user-avatar" hx-swap-oob="true" class="avatar avatar-sm"
        {% if user.avatar %}style="background-image: url('{{ user.avatar.url }}')"{% endif %}>
  </span>
{% endif %}